Attribute VB_Name = "Module1"
Option Explicit
Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Declare Function GetShortPathName Lib "kernel32" Alias "GetShortPathNameA" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long



Sub Main()
'About all that really happens here is the timer gets started. The timer
'calls the "Wakeup" routine where all the real work happens
    'Insure the INI file exists and locate it
    InitializeIniFile
    'Set the check interval in seconds
    InsureKeyIsNotBlank LCase(App.EXEName), "CheckPeriod", "35"
    'Verify program check period is between 1 and 59 seconds
    If Val(GetIni(LCase(App.EXEName), "CheckPeriod")) > 59 Then
        SetIni LCase(App.EXEName), "CheckPeriod", "59"
    End If
    If Val(GetIni(LCase(App.EXEName), "CheckPeriod")) < 1 Then
        SetIni LCase(App.EXEName), "CheckPeriod", "1"
    End If
    'Set the timer to the specified check interval
    frmSchedule.Timer1.Interval = Val(GetIni(LCase(App.EXEName), "CheckPeriod")) * 1000
    WriteLog "Started " & GetIni(LCase(App.EXEName), "Program")
End Sub


Function MonthName(nMonth As Integer) As String
Select Case nMonth
    Case 1
        MonthName = "January"
    Case 2
        MonthName = "February"
    Case 3
        MonthName = "March"
    Case 4
        MonthName = "April"
    Case 5
        MonthName = "May"
    Case 6
        MonthName = "June"
    Case 7
        MonthName = "July"
    Case 8
        MonthName = "August"
    Case 9
        MonthName = "September"
    Case 10
        MonthName = "October"
    Case 11
        MonthName = "November"
    Case 12
        MonthName = "December"
End Select
End Function

Sub Wakeup()
Dim nTaskId As Integer
Dim sYear As String
Dim sMonth As String
Dim sDate As String
Dim sDay As String
Dim sHour As String
Dim sMinute As String
Dim sTask As String
Dim sArgs As String
Dim sPath As String
Static sPreviousMinute As String

    'Don't test more than once per minute
    If sPreviousMinute = Minute(Now) Then Exit Sub
    
    'See what "now" is
    sYear = Year(Now)
    sMonth = MonthName(Month(Now))
    sDate = Day(Now)
    sDay = WeekDayName(WeekDay(Now))
    sHour = Hour(Now)
    sMinute = Minute(Now)
    sPreviousMinute = sMinute
    
    'Loop thru all tasks to see if they are ready
    nTaskId = 1
    While SectionExists(Trim(CStr(nTaskId)))
        'See if the time in the ini file is now
        If Not InCommaDelimitedList(GetIni(Trim(CStr(nTaskId)), "Year"), sYear) Then GoTo NextTask
        If Not InCommaDelimitedList(GetIni(Trim(CStr(nTaskId)), "Month"), sMonth) Then GoTo NextTask
        If Not InCommaDelimitedList(GetIni(Trim(CStr(nTaskId)), "Date"), sDate) Then GoTo NextTask
        If Not InCommaDelimitedList(GetIni(Trim(CStr(nTaskId)), "Day"), sDay) Then GoTo NextTask
        If Not InCommaDelimitedList(GetIni(Trim(CStr(nTaskId)), "Hour"), sHour) Then GoTo NextTask
        If Not InCommaDelimitedList(GetIni(Trim(CStr(nTaskId)), "Minute"), sMinute) Then GoTo NextTask
        'Is there an INI file entry specifying a program
        If Trim(GetIni(Trim(CStr(nTaskId)), "Program")) = "" Then GoTo NextTask
        
        'Find the task and arguments
        sArgs = ""
        sTask = GetIni(Trim(CStr(nTaskId)), "Program")
        If InStr(1, sTask, """", vbTextCompare) = 1 Then
            sArgs = Trim(Mid(sTask, InStr(2, sTask, """", vbTextCompare) + 1))
            sTask = Trim(Mid(sTask, 2, InStr(2, sTask, """", vbTextCompare) - 2))
        Else
            If InStr(1, sTask, " ", vbTextCompare) <> 0 Then
                sArgs = Mid(sTask, InStr(1, sTask, " ", vbTextCompare) + 1)
                sTask = Left(sTask, InStr(1, sTask, " ", vbTextCompare) - 1)
            End If
        End If
        If sArgs = "" Then sArgs = vbNullString
        
        'Does the task exist?
        If Dir(sTask) = "" Then GoTo NextTask
        
        'Try to find the path of the sTask. I could walk backwards thru
        'the sTask string and pull off the file name, but this is more fun.
        'The "GetShortPathName" function returns like this: "D:\:\PROGRA~1"
        'So I have to skip the 2nd and 3rd characters.
        sPath = String(1024, 0)
        sPath = Left(sPath, GetShortPathName(sTask & "\..", sPath, 1024))
        sPath = Left(sPath, 1) & Mid(sPath, 4)
        
        'actually start the task
        ShellExecute frmSchedule.hwnd, "Open", sTask, sArgs, sPath, vbMinimizedNoFocus
        WriteLog "Started " & GetIni(Trim(CStr(nTaskId)), "Program")
            
NextTask:
        nTaskId = nTaskId + 1
    Wend
    
    
End Sub


Private Function InCommaDelimitedList(ByVal sList As String, ByVal sWord As String) As Boolean
Dim nPosition As Integer
'Return true if sWord is in the comma-delimited sList
    
    'Add commas to make start and end searching easier
    sList = "," & sList & ","
    'Check to see if sList string is empty or set to "all"
    If (sList = ",,") Or (LCase(sList) = ",all,") Then
        InCommaDelimitedList = True
        Exit Function
    End If
    'Check for item in list: ,word,
    If InStr(1, sList, "," & sWord & ",", vbTextCompare) <> 0 Then
        InCommaDelimitedList = True
        Exit Function
    End If
    InCommaDelimitedList = False
End Function


Function WeekDayName(nDayNumber) As String
    Select Case nDayNumber
        Case 1
            WeekDayName = "Sunday"
        Case 2
            WeekDayName = "Monday"
        Case 3
            WeekDayName = "Tuesday"
        Case 4
            WeekDayName = "Wednesday"
        Case 5
            WeekDayName = "Thursday"
        Case 6
            WeekDayName = "Friday"
        Case 7
            WeekDayName = "Saturday"
       End Select
End Function


Sub WriteLog(sLogText As String)
    'Is there an INI file entry specifying a log
    If Trim(GetIni(LCase(App.EXEName), "LogFile")) = "" Then Exit Sub
    'Open the log file
    Open Trim(GetIni(LCase(App.EXEName), "LogFile")) For Append As #1
    'Write the log
    Print #1, Now & " " & sLogText
    Close #1
End Sub


